namespace Syntriax.Engine.Core;

/// <summary>
/// Represents a <see cref="IBehaviour"/> to be notified after the update phase of the <see cref="IUniverse"/> occurs.
/// </summary>
public interface IPostUpdate : IBehaviour
{
    /// <summary>
    /// Updates the state of the <see cref="IBehaviour"/> after the main update phase happens.
    /// </summary>
    void PostUpdate();
}
