using Syntriax.Engine.Core;

namespace Syntriax.Engine.Physics2D;

/// <summary>
/// Represents a <see cref="IBehaviour"/> that listens to the phase after the physics simulation phase.
/// </summary>
public interface IPostPhysicsUpdate : IBehaviour
{
    /// <summary>
    /// Execute logic that should occur after the physics simulation has been updated.
    /// </summary>
    /// <param name="delta">The time elapsed since the last physics update, typically in seconds.</param>
    void PostPhysicsUpdate(float delta);
}
