using Syntriax.Engine.Core;

namespace Syntriax.Engine.Systems.Time;

public interface IReadOnlyStopwatch
{
    Event<IReadOnlyStopwatch> OnStarted { get; }
    Event<IReadOnlyStopwatch, StopwatchDeltaArguments> OnDelta { get; }
    Event<IReadOnlyStopwatch> OnStopped { get; }

    double Time { get; }

    TimerState State { get; }

    Event<IReadOnlyStopwatch> OnPaused { get; }
    Event<IReadOnlyStopwatch> OnResumed { get; }

    readonly record struct StopwatchDeltaArguments(double Delta);
}
